package com.devicehive.model.enums;

/*
 * #%L
 * DeviceHive Common Dao Interfaces
 * %%
 * Copyright (C) 2016 DataArt
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */


public enum PluginStatus {
    ACTIVE(0),
    INACTIVE(1),
    CREATED(2);

    private int value;

    PluginStatus(int value) {
        this.value = value;
    }

    public int getValue() {
        return this.value;
    }

    public static PluginStatus getValueForIndex(int index){
        return values()[index];
    }

    public static PluginStatus fromString(final String s) {
        return PluginStatus.valueOf(s.toUpperCase());
    }
}
